#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/ioctl.h>

typedef unsigned char u8;

#include "ak470x.h"

#define AK470X	"/dev/ak470x"

int main(int argc, // Number of strings in array argv
 char *argv[],      // Array of command-line argument strings
 char **envp)
{
        AK470X_REGISTERSET_t werte;
	AK470X_AUDIO_IOCTL_VOLUME_t vol;
//        AK470X_REGISTERSET_t werte;
	int ak470x = open(AK470X, 0);
//	printf("Es wurden %i Argumente übergeben\n", argc);
//        sscanf(argv[1],"%u",&(werte.adresse));
//       sscanf(argv[2],"%u",&(werte.wert));

        if(ak470x == -1)
	{
		printf ("Error opening file \"%s\":\n\t", AK470X);
		perror("open");
		return 1;
	}
		
	printf("Opening file successful\nSending ioctl\n");
	int err = ioctl(ak470x, AK470X_IOCTL_AUDIO_VOLUME_GET, &vol);
	if(err == -1)
	{
		printf("ioctl AK470X_IOCTL_AUDIO_MODE_GET failed:\n\t");
		perror("ioctl");
		close(ak470x);
		return 1;
	}

	// dumping ioctl result
	printf( "vol.master_left = %d\n"
			"vol.master_right = %d\n"
			"vol.audio_channel = %d\n"
			"vol.external_left = %d\n"
			"vol.external_right = %d\n",
			vol.master_left, vol.master_right, vol.audio_channel,
			vol.external_left, vol.external_right);
	vol.audio_channel = 0;
        vol.master_right = 100;
        vol.master_left = 100;
        vol.external_left = 100;
        vol.external_right = 100;
	err = ioctl(ak470x, AK470X_IOCTL_AUDIO_VOLUME_SET, &vol);
        if(err == -1)
        {
                printf("ioctl AK470X_IOCTL_AUDIO_MODE_SET failed:\n\t");
                perror("ioctl");
                close(ak470x);
                return 1;
        }
        sscanf(argv[1],"%u",&(werte.adresse));
        sscanf(argv[2],"%u",&(werte.wert));        
        err = ioctl(ak470x, AK470X_IOCTL_REGISTER, &werte);
        if(err == -1)
        {
                printf("ioctl AK470X_IOCTL_REGISTER failed:\n\t");
                perror("ioctl");
                close(ak470x);
                return 1;
        }


	printf("Schreiben Sound fertig.");

	close(ak470x);

	return 0;
}

